ghc-7.0.3: The GHC API

Vectorise.Type.Classify

Synopsis

- type TyConGroup = ([TyCon], UniqSet TyCon)
- classifyTyCons :: UniqFM Bool -> [TyConGroup] -> ([TyCon], [TyCon])
- tyConGroups :: [TyCon] -> [TyConGroup]

# Documentation

type TyConGroup = ([TyCon], UniqSet TyCon)

classifyTyCons :: UniqFM Bool -> [TyConGroup] -> ([TyCon], [TyCon])

Split the given tycons into two sets depending on whether they have to be converted (first list) or not (second list). The first argument contains information about the conversion status of external tycons:

- tycons which have converted versions are mapped to True * tycons which are not changed by vectorisation are mapped to False * tycons which can't be converted are not elements of the map

tyConGroups :: [TyCon] -> [TyConGroup]

Compute mutually recursive groups of tycons in topological order